function IsIEBrowser() {
  if(navigator.appName=="Microsoft Internet Explorer") return true;
  else return false;
}

function isNameQuirk() {
  var elem1=document.createElement("div");
  var elem2=document.createElement("input");
  elem1.type="hidden";
  elem2.name="testName";
  elem1.appendChild(elem2);
  var isQuirk=(elem1.innerHTML.indexOf("test")==-1);
  isNameQuirk=function() {return isQuirk;}
  return isNameQuirk();
}

function BtnObj(idName, option_value) {
  var _btn=document.createElement('INPUT');
  _btn.type='submit';
  _btn.name=idName;
  _btn.value=option_value;
  
  this.setButtonType=function(btnType) { if(btnType !== null) _btn.type=btnType; };
  this.SetClassName=function(class_Name) { if(class_Name !== null) _btn.className=class_Name; };
  this.GetContainer=function() { return _btn; };
}

function PrintModAddr(ModAddr) {
  var temp=parseInt(ModAddr) < 10000 ? (100000+parseInt(ModAddr)).toString():ModAddr.toString();
  return (parseInt(ModAddr) < 10000 ? temp.substring(1):temp);
}

function RadioObj(idName, curValue, att) {
  var _panel=document.createElement("DIV");

  for(var prop in att) {
    var label = document.createElement("label");
    var radioInput = document.createElement("input");
    radioInput.setAttribute("type", "radio");
    radioInput.setAttribute("value", prop);
    radioInput.setAttribute("id", att[prop]);
    radioInput.setAttribute("name", idName);
    if(curValue == prop) radioInput.setAttribute('checked', 'checked');
    label.for = att[prop];
    label.style.display="inline";
    label.appendChild(radioInput);
    label.innerHTML += att[prop];
    label.style.fontWeight="normal";
    _panel.appendChild(label);
  }

  this.GetContainer=function() { return _panel; }
}

function TextObj(idName, size) {
  var _text;
  var _size=(size!==null?size:12);

  if(isNameQuirk())
    _text=document.createElement("<input type='text' id='"+idName+"' name='"+idName+" size='"+_size+"' maxlength='"+_size+"'>");
  else
    _text=document.createElement('INPUT');

  var att={type:"text", id:idName, name:idName, size:_size, maxlength:10};
  for(var prop in att) { _text.setAttribute(prop, att[prop]); }

  this.SetText=function(caption) { _text.value=caption; }

  this.SetProperty=function(property) {
    for(var prop in property) { _text.setAttribute(prop, property[prop]); }
  }
  
  this.SetEvent = function(events) {
    for(var evt in events) _text[evt]=events[evt];
  }

  this.GetContainer=function() { return _text; }
}

function SelectObj(idName) {
  var _select=document.createElement('SELECT');
  var _option=[];
  var _Index=0;

  _select.name=idName;
  _select.size=1;

  this.AddOption=function(option_value, caption) {
    _option[_Index]=document.createElement('option');
    _option[_Index].value=option_value;
    _option[_Index].appendChild(document.createTextNode(caption));
    _select.appendChild(_option[_Index]);
    _Index+=1;
  }

  this.SelectOption=function(select_idx) {
    for(var i=0; i<_Index; i++){
      if(_option[i].value == select_idx)
        _option[i].selected='selected';
    }
  }

  this.GetContainer=function() { return _select; }
}

function ConfigForm(page, channel) {
  this.container=document.createElement("FORM");
  this.channel_number=channel;
  
  /* Hidden Items */
  var _hidden=document.createElement("INPUT");
  _hidden.type='hidden';
  _hidden.name='page';
  _hidden.value=page;
  this.container.appendChild(_hidden);
  
  var tb=document.createElement("table");
  var tbhead=tb.createTHead();
  this.tbbody=tb.createTBody();
  tb.className="u-full-width";
  this.container.appendChild(tb);

  this.SetFormProperty=function(method, action) {
    this.container.method=method;
    this.container.action=action;
  };

  this.SetFormEvent=function(events) {
    if(events) { for(var evt in events) { this.container[evt]=events[evt]; } }
  };

  /* Set Item Content */
  this.SetItemContent=function(item_property) {
    if(item_property === null) return;

    var row = tbhead.insertRow(0); // creates a table row
    for(var prop in item_property) {
      var cell = document.createElement("th");
      cell.appendChild(document.createTextNode(item_property[prop]));
      row.appendChild(cell);
    }

    for(var i=0; i < this.channel_number; i++) {
      var row = this.tbbody.insertRow(i); // creates a table row
      for(var prop in item_property) {
        var cell = document.createElement("td");
        if(prop==0 && item_property[0] == "Channel") {
          cell.appendChild(document.createTextNode("Ch" + i.toString()));
        }
        row.appendChild(cell);
      }
    }
  };

  this.AddItem=function(channel, item_index, io_type, item_no, item_value, events, property) {
    var _name, _temp;

    if(io_type==0) { _name="DO"+item_no; _temp=DOarr[item_no]; }
    else if(io_type==1) { _name="DI"+item_no; _temp=DIarr[item_no]; }
    else if(io_type==3) { _name="AI"+item_no; _temp=AIarr[item_no]; }
    else if(io_type==4) { _name="AO"+item_no; _temp=AOarr[item_no]; }

    if(channel < 0 || channel >= this.channel_number) return;

    var row = this.tbbody.getElementsByTagName('tr')[channel];

    if(_temp.type==0) { // checkbox
      var _checkbox;
      if(isNameQuirk()) _checkbox=document.createElement("<input type='checkbox' name="+_name+">");
      else _checkbox=document.createElement("INPUT");

      _checkbox.type="checkbox";
      _checkbox.name=_name;
      _checkbox.value="on";

      if(property !== null) { for(var prop in property) _checkbox.setAttribute(prop, property[prop]); }

      if(events) { for(var evt in events) _checkbox[evt]=events[evt]; }

      row.getElementsByTagName('td')[item_index].appendChild(_checkbox);
    } else if(_temp.type==1) { // radio
      var _redio=new RadioObj(_name, item_value?"on":"off", property);
      row.getElementsByTagName('td')[item_index].appendChild(_redio.GetContainer());
    } else if(_temp.type==2) { // text
      var _text=new TextObj(_name, 16);

      _text.SetProperty(property);
      _text.SetText(item_value);

      row.getElementsByTagName('td')[item_index].appendChild(_text.GetContainer());
    } else if(_temp.type==3) { // select
      var _select=new SelectObj(_name);
      for(var prop in property) { _select.AddOption(prop, property[prop]); }

      _select.SelectOption(item_value);
      row.getElementsByTagName('td')[item_index].appendChild(_select.GetContainer());
    }

    if(_temp.common) {
      row.getElementsByTagName('td')[0].appendChild(document.createTextNode(PrintModAddr(io_type*10000 + item_no).toString()));
      row.getElementsByTagName('td')[1].appendChild(document.createTextNode(_temp.caption));

      if(_temp.note !== "") {
        var note_span=document.createElement("span");
        note_span.appendChild(document.createTextNode("\u00a0" + _temp.note));
        row.getElementsByTagName('td')[2].appendChild(note_span);
      }
    } else if(_temp.note !== "") {
      var note_span=document.createElement("span");
      note_span.appendChild(document.createTextNode("\u00a0"+_temp.note));
      row.getElementsByTagName('td')[2].appendChild(note_span);
    }
  };

  this.AddHiddenItem=function(item_name, item_value) {
    var _hidden=document.createElement("INPUT");
    _hidden.type='hidden';
    _hidden.name=item_name;
    _hidden.value=item_value;
    this.container.appendChild(_hidden);
  };

  this.AddSubmitBtn=function() {
    var _item=document.createElement("DIV");
    var _btnSubmit=new BtnObj('submit', 'Submit');
    _btnSubmit.SetClassName("button button-primary");
    _item.setAttribute('align', 'center');
    _item.appendChild(_btnSubmit.GetContainer());
    this.container.appendChild(_item);
  };

  this.GetContainer=function() { return this.container; };
}